diff --git a/sysdeps/unix/sysv/linux/Makefile b/sysdeps/unix/sysv/linux/Makefile
index 710169a454..982755f980 100644
--- a/sysdeps/unix/sysv/linux/Makefile
+++ b/sysdeps/unix/sysv/linux/Makefile
@@ -61,7 +61,7 @@ sysdep_routines += adjtimex clone umount umount2 readahead sysctl \
 		   open_by_handle_at mlock2 pkey_mprotect pkey_set pkey_get \
 		   timerfd_gettime timerfd_settime prctl \
 		   process_vm_readv process_vm_writev clock_adjtime \
-		   time64-support pselect32 select32 \
+		   pselect32 select32 \
 		   xstat fxstat lxstat xstat64 fxstat64 lxstat64 \
 		   fxstatat fxstatat64 \
 		   xmknod xmknodat convert_scm_timestamps
diff --git a/sysdeps/unix/sysv/linux/time64-support.c b/sysdeps/unix/sysv/linux/time64-support.c
deleted file mode 100644
index 0718e7421b..0000000000
--- a/sysdeps/unix/sysv/linux/time64-support.c
+++ /dev/null
@@ -1,23 +0,0 @@
-/* Auxiliary definitions for 64-bit time_t support.
-   Copyright (C) 2020-2021 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <https://www.gnu.org/licenses/>.  */
-
-#include <time64-support.h>
-
-#ifndef __ASSUME_TIME64_SYSCALLS
-int __time64_support = 1;
-#endif
diff --git a/sysdeps/unix/sysv/linux/time64-support.h b/sysdeps/unix/sysv/linux/time64-support.h
deleted file mode 100644
index 8466d37f8f..0000000000
--- a/sysdeps/unix/sysv/linux/time64-support.h
+++ /dev/null
@@ -1,70 +0,0 @@
-/* Auxiliary definitions for 64-bit time_t support.
-   Copyright (C) 2020-2021 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <https://www.gnu.org/licenses/>.  */
-
-#include <stdbool.h>
-#include <atomic.h>
-
-/* These helper functions are used to optimize the 64-bit time_t support on
-   configurations that requires support for 32-bit time_t fallback
-   (!__ASSUME_TIME64_SYSCALLS).  The idea is once the kernel advertises that
-   it does not have 64-bit time_t support, glibc will stop to try issue the
-   64-bit time_t syscall altogether.
-
-   For instance:
-
-     #ifndef __NR_symbol_time64
-     # define __NR_symbol_time64 __NR_symbol
-     #endif
-     int r;
-     if (supports_time64 ())
-       {
-         r = INLINE_SYSCALL_CALL (symbol, ...);
-         if (r == 0 || errno != ENOSYS)
-	   return r;
-
-         mark_time64_unsupported ();
-       }
-     #ifndef __ASSUME_TIME64_SYSCALLS
-     <32-bit fallback syscall>
-     #endif
-     return r;
-
-   On configuration with default 64-bit time_t this optimization should be
-   optimized away by the compiler resulting in no overhead.  */
-
-#ifndef __ASSUME_TIME64_SYSCALLS
-extern int __time64_support attribute_hidden;
-#endif
-
-static inline bool
-supports_time64 (void)
-{
-#ifdef __ASSUME_TIME64_SYSCALLS
-  return true;
-#else
-  return atomic_load_relaxed (&__time64_support) != 0;
-#endif
-}
-
-static inline void
-mark_time64_unsupported (void)
-{
-#ifndef __ASSUME_TIME64_SYSCALLS
-  atomic_store_relaxed (&__time64_support, 0);
-#endif
-}