diff --git a/sysdeps/unix/sysv/linux/clock_nanosleep.c b/sysdeps/unix/sysv/linux/clock_nanosleep.c
index 007f1736cb..46b0f1e269 100644
--- a/sysdeps/unix/sysv/linux/clock_nanosleep.c
+++ b/sysdeps/unix/sysv/linux/clock_nanosleep.c
@@ -27,8 +27,9 @@
 /* We can simply use the syscall.  The CPU clocks are not supported
    with this function.  */
 int
-__clock_nanosleep_time64 (clockid_t clock_id, int flags, const struct __timespec64 *req,
-                          struct __timespec64 *rem)
+__clock_nanosleep_time64 (clockid_t clock_id, int flags,
+			  const struct __timespec64 *req,
+			  struct __timespec64 *rem)
 {
   if (clock_id == CLOCK_THREAD_CPUTIME_ID)
     return EINVAL;
@@ -37,33 +38,37 @@ __clock_nanosleep_time64 (clockid_t clock_id, int flags, const struct __timespec
 
   /* If the call is interrupted by a signal handler or encounters an error,
      it returns a positive value similar to errno.  */
+
 #ifndef __NR_clock_nanosleep_time64
 # define __NR_clock_nanosleep_time64 __NR_clock_nanosleep
 #endif
-  int r = INTERNAL_SYSCALL_CANCEL (clock_nanosleep_time64, clock_id,
-				   flags, req, rem);
-
-#ifndef __ASSUME_TIME64_SYSCALLS
-  if (r == 0 || r != -ENOSYS)
-    return -r;
 
-  if (! in_time_t_range (req->tv_sec))
+  int r;
+#ifdef __ASSUME_TIME64_SYSCALLS
+  r = INTERNAL_SYSCALL_CANCEL (clock_nanosleep_time64, clock_id, flags, req,
+			       rem);
+#else
+  bool is32bit = in_time_t_range (req->tv_sec);
+  if (!is32bit)
     {
-      __set_errno (EOVERFLOW);
-      return -1;
+      r = INTERNAL_SYSCALL_CANCEL (clock_nanosleep_time64, clock_id, flags,
+				   req, rem);
+      if (r == -ENOSYS)
+	r = -EOVERFLOW;
     }
-
-  struct timespec tr32;
-  struct timespec ts32 = valid_timespec64_to_timespec (*req);
-  r = INTERNAL_SYSCALL_CANCEL (clock_nanosleep, clock_id, flags,
-                               &ts32, &tr32);
-  if (INTERNAL_SYSCALL_ERROR_P (r))
+  else
     {
-      if (r == -EINTR && rem != NULL && (flags & TIMER_ABSTIME) == 0)
-	*rem = valid_timespec_to_timespec64 (tr32);
+      struct timespec tr32;
+      struct timespec ts32 = valid_timespec64_to_timespec (*req);
+      r = INTERNAL_SYSCALL_CANCEL (clock_nanosleep, clock_id, flags, &ts32,
+				   &tr32);
+      if (INTERNAL_SYSCALL_ERROR_P (r))
+	{
+	  if (r == -EINTR && rem != NULL && (flags & TIMER_ABSTIME) == 0)
+	    *rem = valid_timespec_to_timespec64 (tr32);
+	}
     }
-#endif /* __ASSUME_TIME64_SYSCALLS */
-
+#endif
   return -r;
 }
 
diff --git a/time/Makefile b/time/Makefile
index c84bd5d3ec..0bea84966c 100644
--- a/time/Makefile
+++ b/time/Makefile
@@ -86,6 +86,15 @@ $(objpfx)tst-strftime2.out: $(gen-locales)
 $(objpfx)tst-strftime3.out: $(gen-locales)
 endif
 
+ifeq (yes,$(build-shared))
+librt = $(common-objpfx)rt/librt.so
+else
+librt = $(common-objpfx)rt/librt.a
+endif
+
+$(objpfx)tst-clock_nanosleep: $(librt)
+$(objpfx)tst-clock_nanosleep-time64: $(librt)
+
 tz-cflags = -DTZDIR='"$(zonedir)"' \
 	    -DTZDEFAULT='"$(localtime-file)"' \
 	    -DTZDEFRULES='"$(posixrules-file)"'
diff --git a/time/tst-clock_nanosleep.c b/time/tst-clock_nanosleep.c
index 47537435c1..a5a7f9430a 100644
--- a/time/tst-clock_nanosleep.c
+++ b/time/tst-clock_nanosleep.c
@@ -20,38 +20,48 @@
 #include <unistd.h>
 #include <sys/time.h>
 #include <time.h>
-
+#include <intprops.h>
+#include <support/support.h>
+#include <support/check.h>
 
 /* Test that clock_nanosleep() does sleep.  */
-static int
-do_test (void)
+static void
+clock_nanosleep_test (void)
 {
   /* Current time.  */
   struct timeval tv1;
-  (void) gettimeofday (&tv1, NULL);
+  gettimeofday (&tv1, NULL);
 
-  struct timespec ts;
-  ts.tv_sec = 1;
-  ts.tv_nsec = 0;
+  struct timespec ts = { 1, 0 };
   TEMP_FAILURE_RETRY (clock_nanosleep (CLOCK_REALTIME, 0, &ts, &ts));
 
   /* At least one second must have passed.  */
   struct timeval tv2;
-  (void) gettimeofday (&tv2, NULL);
+  gettimeofday (&tv2, NULL);
 
   tv2.tv_sec -= tv1.tv_sec;
   tv2.tv_usec -= tv1.tv_usec;
   if (tv2.tv_usec < 0)
     --tv2.tv_sec;
 
-  if (tv2.tv_sec < 1)
-    {
-      puts ("clock_nanosleep didn't sleep long enough");
-      return 1;
-    }
+  TEST_VERIFY (tv2.tv_sec >= 1);
+}
+
+static void
+clock_nanosleep_large_timeout (void)
+{
+  support_create_timer (0, 100000000, false, NULL);
+  struct timespec ts = { TYPE_MAXIMUM (time_t), 0 };
+  int r = clock_nanosleep (CLOCK_REALTIME, 0, &ts, NULL);
+  TEST_VERIFY (r == EINTR || r == EOVERFLOW);
+}
 
+static int
+do_test (void)
+{
+  clock_nanosleep_test ();
+  clock_nanosleep_large_timeout ();
   return 0;
 }
 
-#define TEST_FUNCTION do_test ()
-#include "../test-skeleton.c"
+#include <support/test-driver.c>