diff --git a/sysdeps/unix/sysv/linux/internal-ioctl.h b/sysdeps/unix/sysv/linux/internal-ioctl.h
new file mode 100644
index 0000000000..697b086703
--- /dev/null
+++ b/sysdeps/unix/sysv/linux/internal-ioctl.h
@@ -0,0 +1,23 @@
+/* Linux internal definitions for ioctl.
+   Copyright (C) 2021 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library.  If not, see
+   <https://www.gnu.org/licenses/>.  */
+
+static inline bool
+__ioctl_arch (int *r, int fd, unsigned long request, void *arg)
+{
+  return false;
+}
diff --git a/sysdeps/unix/sysv/linux/ioctl.c b/sysdeps/unix/sysv/linux/ioctl.c
new file mode 100644
index 0000000000..c4855d6302
--- /dev/null
+++ b/sysdeps/unix/sysv/linux/ioctl.c
@@ -0,0 +1,49 @@
+/* Control device.  Linux generic implementation.
+   Copyright (C) 2021 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library.  If not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include <stdarg.h>
+#include <sys/ioctl.h>
+#include <sysdep.h>
+#include <internal-ioctl.h>
+
+int
+__ioctl (int fd, unsigned long int request, ...)
+{
+  va_list args;
+  va_start (args, request);
+  void *arg = va_arg (args, void *);
+  va_end (args);
+
+  int r;
+  if (!__ioctl_arch (&r, fd, request, arg))
+    {
+      r = INTERNAL_SYSCALL_CALL (ioctl, fd, request, arg);
+      if (__glibc_unlikely (INTERNAL_SYSCALL_ERROR_P (r)))
+	{
+	  __set_errno (-r);
+	  return -1;
+	}
+    }
+  return r;
+}
+libc_hidden_def (__ioctl)
+weak_alias (__ioctl, ioctl)
+
+#if __TIMESIZE != 64
+strong_alias (__ioctl, __ioctl_time64)
+#endif
diff --git a/sysdeps/unix/sysv/linux/powerpc/internal-ioctl.h b/sysdeps/unix/sysv/linux/powerpc/internal-ioctl.h
new file mode 100644
index 0000000000..3a2adce7c3
--- /dev/null
+++ b/sysdeps/unix/sysv/linux/powerpc/internal-ioctl.h
@@ -0,0 +1,46 @@
+/* Linux internal definitions for ioctl.
+   Copyright (C) 2021 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library.  If not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include <termios.h>
+
+static inline bool
+__ioctl_arch (int *r, int fd, unsigned long request, void *arg)
+{
+  switch (request)
+    {
+    case TCGETS:
+      *r = __tcgetattr (fd, (struct termios *) arg);
+      break;
+
+    case TCSETS:
+      *r = __tcsetattr (fd, TCSANOW, (struct termios *) arg);
+      break;
+
+    case TCSETSW:
+      *r = __tcsetattr (fd, TCSADRAIN, (struct termios *) arg);
+      break;
+
+    case TCSETSF:
+      *r = __tcsetattr (fd, TCSAFLUSH, (struct termios *) arg);
+      break;
+
+    default:
+      return false;
+    }
+  return true;
+}
diff --git a/sysdeps/unix/sysv/linux/powerpc/ioctl.c b/sysdeps/unix/sysv/linux/powerpc/ioctl.c
deleted file mode 100644
index a81c7ba54c..0000000000
--- a/sysdeps/unix/sysv/linux/powerpc/ioctl.c
+++ /dev/null
@@ -1,68 +0,0 @@
-/* Copyright (C) 1998-2021 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <https://www.gnu.org/licenses/>.  */
-
-#include <stdarg.h>
-#include <termios.h>
-#include <unistd.h>
-#include <sys/ioctl.h>
-#include <sysdep.h>
-
-/* The user-visible size of struct termios has changed.  Catch ioctl calls
-   using the new-style struct termios, and translate them to old-style.  */
-
-int
-__ioctl (int fd, unsigned long int request, ...)
-{
-  void *arg;
-  va_list ap;
-  int result;
-
-  va_start (ap, request);
-  arg = va_arg (ap, void *);
-
-  switch (request)
-    {
-    case TCGETS:
-      result = __tcgetattr (fd, (struct termios *) arg);
-      break;
-
-    case TCSETS:
-      result = __tcsetattr (fd, TCSANOW, (struct termios *) arg);
-      break;
-
-    case TCSETSW:
-      result = __tcsetattr (fd, TCSADRAIN, (struct termios *) arg);
-      break;
-
-    case TCSETSF:
-      result = __tcsetattr (fd, TCSAFLUSH, (struct termios *) arg);
-      break;
-
-    default:
-      result = INLINE_SYSCALL (ioctl, 3, fd, request, arg);
-      break;
-    }
-
-  va_end (ap);
-
-  return result;
-}
-libc_hidden_def (__ioctl)
-weak_alias (__ioctl, ioctl)
-#if __TIMESIZE != 64
-weak_alias (__ioctl, __ioctl_time64)
-#endif